%% MATH3360 Tutorial3 Demonstration on Harr Transform
% Remark: For demostration reason, we use imshow in this script.
% Please use imwrite instead of imshow when you try to run this script
clear all;
I=imread('beach.jpeg');
[width, height, depth]=size(I);
I=double(I);
% A function can output a haar matrix with input dimension n
% Note: It is not a buildin function,please write it by yourself
H=haarmtx(width);
% To show the transform is invertable
for i=1:depth
    I_trans(:,:,i)=H*I(:,:,i)*H';
end
for i=1:depth
    I_re(:,:,i)=H'*I_trans(:,:,i)*H;
end
imshow(uint8(I));
title('Original image');
figure 
% Note: The transformed image is compactly support 
imshow(rgb2gray(uint8(I_trans)));
title('Transformed image');
figure
imshow(uint8(I_re));
title('Restructed image');
error=max(max(max(abs(I-I_re))))
% Compress the image by truncate the bottom half of transformed image,
% i.e. only using half information of original image to reconstruct
I_trun=I_trans;
I_trun(width/2:end,:)=0;
for i=1:depth
    I_re_trun(:,:,i)=H'*I_trun(:,:,i)*H;
end
figure
imshow(uint8(I_re_trun));
title('Compressed reconstructed image');
res=I_re_trun-I;
figure
imshow(uint8(abs(res)))
title('Residue image');
